using UnityEngine;
using System.Collections;
using System.Timers;

public class shooterLaser : MonoBehaviour {

	private GameObject laser;
	private LineRenderer laserLine;
	private Vector3 laserPoint0Pos;
	private Vector3 laserPoint1Pos;
	private int weaponChoice=0;
	private bool gameIsOver = false;
	
	
	private GameObject timerObject;
	private float gameTime = 60; //countdown time
	public Material[] TimerColors;
	
	public GameObject[] projectileList;
	
	
	// Use this for initialization
	void Start () {
		
		laser = this.gameObject;
		laserLine = (LineRenderer)laser.GetComponent("LineRenderer");
		laserPoint0Pos = new Vector3(0,20,0);
		timerObject = GameObject.FindGameObjectWithTag("timer");
		
		
	}
	
	// Update is called once per frame
	void Update () {
	
		float laserPointerX=Screen.width/2- Input.mousePosition.x;
		float laserPointerY=Input.mousePosition.y;
		
		//don't allow laser to go under screen
		if(laserPointerY <0){
			laserPointerY=0;
		}
		
		laserPoint1Pos = new Vector3(laserPointerX,laserPointerY,0);
		
		//move laser to mouse position
		laserLine.SetPosition(1, laserPoint1Pos);
		
		//shooting bullets, in direction wich laser is pointing
		if(!gameIsOver && Input.GetMouseButtonDown(0)){
			
			GameObject.Instantiate(projectileList[weaponChoice],this.transform.position,Quaternion.FromToRotation(Vector3.up,laserPoint1Pos));
		}
	
		
		
		// choose weapon
		if(Input.GetKeyDown(KeyCode.Alpha1)){
			
			weaponChoice = 0;
		}else if(Input.GetKeyDown(KeyCode.Alpha2)){
			
			weaponChoice = 1;
		}else if(Input.GetKeyDown(KeyCode.Alpha3)){
			
			weaponChoice = 2;
		}else if(Input.GetKeyDown(KeyCode.Alpha4)){
			
			weaponChoice = 3;
		}
		
		gameTime -= Time.deltaTime;
		int offsetTimeSubstr=2;
		if(gameTime <= 10){
			offsetTimeSubstr=1;
		}
		if(gameTime < 0){
			gameTime = 0;
		}
		
		((TextMesh)timerObject.GetComponent("TextMesh")).text = ((string)""+gameTime).Substring(0,offsetTimeSubstr);
		
		
		if(gameTime >30){
		
			((MeshRenderer)timerObject.GetComponent("MeshRenderer")).material.color = Color.green;
			
		}else if(gameTime >10){
			
			((MeshRenderer)timerObject.GetComponent("MeshRenderer")).material.color = Color.yellow;
			
		}else{
			((MeshRenderer)timerObject.GetComponent("MeshRenderer")).material.color = Color.red;
			
		}
		
		
		if(gameTime <= 0){
			gameIsOver = true;
			
		} 
	}
	
	void OnGUI(){
		
		if(gameIsOver)
		GUILayout.Window(0,new Rect(Screen.width/2 - 500/2 ,Screen.height/2 - 100/2 ,500,100), menu,"Pony Over\n Your score: " + ((TextMesh)GameObject.FindGameObjectWithTag("score").GetComponent("TextMesh")).text );
		
	}
	
	private void menu(int windowID){
		
		
			GUILayout.Space(15);//leaves a gap from the header
			
			if(GUILayout.Button("Return",GUILayout.Height(50))){
				Application.LoadLevel(0);
			}
		
	}
}
